from math import sqrt


n = int(input())

sep = '='
print(f"{n} ", end="")

# vamos lidar com o divisor 2 a parte para  pode incrementar o fator de 2 em 2
# na próxima etapa
while n > 1 and n % 2 == 0:
    print(f"{sep} 2 ", end="")
    n = n // 2
    if sep == '=':
        sep = 'x'

fator = 3
# Se n não é primo, então existe um fator de n que é menor que  sqrt(n)
while fator <= sqrt(n):
    if n % fator == 0:
        print(f"{sep} {fator} ", end="")
        n = n // fator
        if sep == '=':
            sep = 'x'
    else:
        fator += 2

# Se o n original era potência de 2, então o valor de n foi reduzido a 1, que
# não é primo e o segundo laço não realizou nenhuma iteração. Se o n original
# não era potência de 2, então o segundo laço irá parar qndo n se tornar um
# primo. O código abaixo imprime esse primo restante.
if n > 1:
    print(f"{sep} {n}", end="")
print()

# Note que  esse código, apesar de mais eficiente que a versão anterior, é bem
# mais complicado e difícil de entender. Além disso,  esse ganho de eficiência
# não refletiu em uma melhora significativa na prática. Veja o benchmark
# reportado abaixo. Por isso, a seguinte frase serve  de alerta para todo
# computeiro:

#       "Premature optimization is the root of all evil" -- Donald Knuth

# msambinelli at thinkpad in ~pi/Slides/lacos-parte3/gabaritos on master   
# ⊢ time python ex5-fatoracao-versao2.py
# 1764132439879874145 = 3 x 5 x 29 x 79 x 2897 x 16223 x 1092283
# python ex5-fatoracao-versao2.py  0,03s user 0,00s system 98% cpu 0,033 total

# msambinelli at thinkpad in ~pi/Slides/lacos-parte3/gabaritos on master   
# ⊢ time python ex5-fatoracao-versao1.py                                                                                                  
# 1764132439879874145 = 3 x 5 x 29 x 79 x 2897 x 16223 x 1092283 
# python ex5-fatoracao-versao1.py  0,18s user 0,01s system 99% cpu 0,191 total
